#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './HelpWidgetGUI.ui'
**
** Created by User Interface Compiler
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "HelpWidgetGUI.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qtextedit.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

/*
 *  Constructs a HelpForm as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
HelpForm::HelpForm( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "HelpForm" );
    HelpFormLayout = new QGridLayout( this, 1, 1, 11, 6, "HelpFormLayout"); 

    groupBox8 = new QGroupBox( this, "groupBox8" );
    groupBox8->setColumnLayout(0, Qt::Vertical );
    groupBox8->layout()->setSpacing( 6 );
    groupBox8->layout()->setMargin( 11 );
    groupBox8Layout = new QGridLayout( groupBox8->layout() );
    groupBox8Layout->setAlignment( Qt::AlignTop );

    helpBrowser = new QTextEdit( groupBox8, "helpBrowser" );
    helpBrowser->setEnabled( TRUE );
    QFont helpBrowser_font(  helpBrowser->font() );
    helpBrowser_font.setFamily( "Courier 10 Pitch" );
    helpBrowser->setFont( helpBrowser_font ); 
    helpBrowser->setFocusPolicy( QTextEdit::ClickFocus );
    helpBrowser->setReadOnly( TRUE );

    groupBox8Layout->addMultiCellWidget( helpBrowser, 0, 0, 0, 1 );

    textLabel1 = new QLabel( groupBox8, "textLabel1" );

    groupBox8Layout->addWidget( textLabel1, 1, 0 );

    searchString = new QLineEdit( groupBox8, "searchString" );
    searchString->setMouseTracking( FALSE );
    searchString->setFocusPolicy( QLineEdit::StrongFocus );

    groupBox8Layout->addWidget( searchString, 1, 1 );

    HelpFormLayout->addWidget( groupBox8, 0, 0 );
    languageChange();
    resize( QSize(600, 480).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( searchString, SIGNAL( returnPressed() ), this, SLOT( helpSearchString() ) );
    connect( searchString, SIGNAL( textChanged(const QString&) ), this, SLOT( helpSearchString() ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
HelpForm::~HelpForm()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void HelpForm::languageChange()
{
    setCaption( tr2i18n( "Form1" ) );
    groupBox8->setTitle( tr2i18n( "Help" ) );
    textLabel1->setText( tr2i18n( "Search" ) );
}

void HelpForm::helpSearchString()
{
    qWarning( "HelpForm::helpSearchString(): Not implemented yet" );
}

#include "HelpWidgetGUI.moc"
