#include <kdialog.h>
#include <klocale.h>
/****************************************************************************
** Form implementation generated from reading ui file './raytracerwidgetbase.ui'
**
** Created by User Interface Compiler
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#include "raytracerwidgetbase.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qtabwidget.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qcheckbox.h>
#include <qtextedit.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

/*
 *  Constructs a raytracerWidgetBase as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 */
raytracerWidgetBase::raytracerWidgetBase( QWidget* parent, const char* name, WFlags fl )
    : QWidget( parent, name, fl )
{
    if ( !name )
	setName( "raytracerwidgetbase" );
    setMinimumSize( QSize( 400, 300 ) );
    QFont f( font() );
    f.setFamily( "Courier 10 Pitch" );
    setFont( f ); 
    setMouseTracking( FALSE );
    setFocusPolicy( QWidget::NoFocus );
    raytracerwidgetbaseLayout = new QGridLayout( this, 1, 1, 11, 6, "raytracerwidgetbaseLayout"); 

    mainTabWidget = new QTabWidget( this, "mainTabWidget" );
    QFont mainTabWidget_font(  mainTabWidget->font() );
    mainTabWidget_font.setFamily( "Sans" );
    mainTabWidget->setFont( mainTabWidget_font ); 
    mainTabWidget->setMouseTracking( FALSE );
    mainTabWidget->setFocusPolicy( QTabWidget::NoFocus );
    mainTabWidget->setTabPosition( QTabWidget::Bottom );

    rayTracePage = new QWidget( mainTabWidget, "rayTracePage" );
    rayTracePageLayout = new QGridLayout( rayTracePage, 1, 1, 11, 6, "rayTracePageLayout"); 

    mainGroupBox = new QGroupBox( rayTracePage, "mainGroupBox" );
    mainGroupBox->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)3, (QSizePolicy::SizeType)3, 0, 0, mainGroupBox->sizePolicy().hasHeightForWidth() ) );
    mainGroupBox->setMouseTracking( FALSE );
    mainGroupBox->setColumnLayout(0, Qt::Vertical );
    mainGroupBox->layout()->setSpacing( 6 );
    mainGroupBox->layout()->setMargin( 11 );
    mainGroupBoxLayout = new QGridLayout( mainGroupBox->layout() );
    mainGroupBoxLayout->setAlignment( Qt::AlignTop );

    graphicDisplay = new QLabel( mainGroupBox, "graphicDisplay" );
    graphicDisplay->setEnabled( TRUE );
    graphicDisplay->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)7, (QSizePolicy::SizeType)7, 0, 0, graphicDisplay->sizePolicy().hasHeightForWidth() ) );
    graphicDisplay->setPaletteForegroundColor( QColor( 0, 0, 0 ) );
    graphicDisplay->setPaletteBackgroundColor( QColor( 255, 255, 255 ) );
    graphicDisplay->setBackgroundOrigin( QLabel::WidgetOrigin );
    graphicDisplay->setMouseTracking( FALSE );
    graphicDisplay->setFocusPolicy( QLabel::TabFocus );

    mainGroupBoxLayout->addMultiCellWidget( graphicDisplay, 0, 0, 0, 4 );

    statusEdit = new QLineEdit( mainGroupBox, "statusEdit" );
    statusEdit->setEnabled( FALSE );
    statusEdit->setPaletteForegroundColor( QColor( 0, 0, 0 ) );
    statusEdit->setPaletteBackgroundColor( QColor( 255, 255, 255 ) );
    statusEdit->setFocusPolicy( QLineEdit::NoFocus );
    statusEdit->setFrameShape( QLineEdit::NoFrame );

    mainGroupBoxLayout->addWidget( statusEdit, 1, 0 );

    showHideButton = new QPushButton( mainGroupBox, "showHideButton" );
    showHideButton->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, showHideButton->sizePolicy().hasHeightForWidth() ) );

    mainGroupBoxLayout->addWidget( showHideButton, 1, 4 );

    deleteButton = new QPushButton( mainGroupBox, "deleteButton" );
    deleteButton->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, deleteButton->sizePolicy().hasHeightForWidth() ) );
    deleteButton->setMaximumSize( QSize( 60, 32767 ) );

    mainGroupBoxLayout->addWidget( deleteButton, 1, 3 );

    cloneButton = new QPushButton( mainGroupBox, "cloneButton" );
    cloneButton->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, cloneButton->sizePolicy().hasHeightForWidth() ) );
    cloneButton->setMaximumSize( QSize( 60, 32767 ) );

    mainGroupBoxLayout->addWidget( cloneButton, 1, 2 );

    newButton = new QPushButton( mainGroupBox, "newButton" );
    newButton->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, newButton->sizePolicy().hasHeightForWidth() ) );
    newButton->setMaximumSize( QSize( 60, 32767 ) );

    mainGroupBoxLayout->addWidget( newButton, 1, 1 );

    controlPanelGroup = new QGroupBox( mainGroupBox, "controlPanelGroup" );
    controlPanelGroup->setEnabled( TRUE );
    controlPanelGroup->setColumnLayout(0, Qt::Vertical );
    controlPanelGroup->layout()->setSpacing( 6 );
    controlPanelGroup->layout()->setMargin( 11 );
    controlPanelGroupLayout = new QGridLayout( controlPanelGroup->layout() );
    controlPanelGroupLayout->setAlignment( Qt::AlignTop );

    textLabel1_3 = new QLabel( controlPanelGroup, "textLabel1_3" );

    controlPanelGroupLayout->addMultiCellWidget( textLabel1_3, 0, 0, 3, 4 );

    textLabel1_2_2_2_3 = new QLabel( controlPanelGroup, "textLabel1_2_2_2_3" );

    controlPanelGroupLayout->addMultiCellWidget( textLabel1_2_2_2_3, 1, 1, 3, 4 );

    rightRadiusText = new QLineEdit( controlPanelGroup, "rightRadiusText" );
    rightRadiusText->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, rightRadiusText->sizePolicy().hasHeightForWidth() ) );
    rightRadiusText->setMinimumSize( QSize( 40, 0 ) );
    rightRadiusText->setMaximumSize( QSize( 32767, 32767 ) );

    controlPanelGroupLayout->addWidget( rightRadiusText, 2, 5 );

    lensRadiusText = new QLineEdit( controlPanelGroup, "lensRadiusText" );
    lensRadiusText->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, lensRadiusText->sizePolicy().hasHeightForWidth() ) );
    lensRadiusText->setMinimumSize( QSize( 40, 0 ) );
    lensRadiusText->setMaximumSize( QSize( 32767, 32767 ) );

    controlPanelGroupLayout->addMultiCellWidget( lensRadiusText, 0, 0, 1, 2 );

    textLabel1 = new QLabel( controlPanelGroup, "textLabel1" );

    controlPanelGroupLayout->addWidget( textLabel1, 0, 0 );

    textLabel1_2_2_2 = new QLabel( controlPanelGroup, "textLabel1_2_2_2" );

    controlPanelGroupLayout->addWidget( textLabel1_2_2_2, 1, 0 );

    textLabel1_2 = new QLabel( controlPanelGroup, "textLabel1_2" );

    controlPanelGroupLayout->addWidget( textLabel1_2, 2, 0 );

    leftCurvatureText = new QLineEdit( controlPanelGroup, "leftCurvatureText" );
    leftCurvatureText->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, leftCurvatureText->sizePolicy().hasHeightForWidth() ) );
    leftCurvatureText->setMinimumSize( QSize( 40, 0 ) );
    leftCurvatureText->setMaximumSize( QSize( 32767, 32767 ) );

    controlPanelGroupLayout->addMultiCellWidget( leftCurvatureText, 1, 1, 1, 2 );

    leftRadiusText = new QLineEdit( controlPanelGroup, "leftRadiusText" );
    leftRadiusText->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, leftRadiusText->sizePolicy().hasHeightForWidth() ) );
    leftRadiusText->setMinimumSize( QSize( 40, 0 ) );
    leftRadiusText->setMaximumSize( QSize( 32767, 32767 ) );

    controlPanelGroupLayout->addMultiCellWidget( leftRadiusText, 2, 2, 1, 2 );

    textLabel1_2_2 = new QLabel( controlPanelGroup, "textLabel1_2_2" );

    controlPanelGroupLayout->addMultiCellWidget( textLabel1_2_2, 2, 2, 3, 4 );

    rightCurvatureText = new QLineEdit( controlPanelGroup, "rightCurvatureText" );
    rightCurvatureText->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, rightCurvatureText->sizePolicy().hasHeightForWidth() ) );
    rightCurvatureText->setMinimumSize( QSize( 40, 0 ) );
    rightCurvatureText->setMaximumSize( QSize( 32767, 32767 ) );

    controlPanelGroupLayout->addWidget( rightCurvatureText, 1, 5 );

    thicknessText = new QLineEdit( controlPanelGroup, "thicknessText" );
    thicknessText->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, thicknessText->sizePolicy().hasHeightForWidth() ) );
    thicknessText->setMinimumSize( QSize( 40, 0 ) );
    thicknessText->setMaximumSize( QSize( 32767, 32767 ) );

    controlPanelGroupLayout->addWidget( thicknessText, 0, 5 );

    textLabel1_3_2 = new QLabel( controlPanelGroup, "textLabel1_3_2" );

    controlPanelGroupLayout->addWidget( textLabel1_3_2, 0, 6 );

    textLabel1_2_2_2_2 = new QLabel( controlPanelGroup, "textLabel1_2_2_2_2" );

    controlPanelGroupLayout->addWidget( textLabel1_2_2_2_2, 1, 6 );

    textLabel1_2_3 = new QLabel( controlPanelGroup, "textLabel1_2_3" );

    controlPanelGroupLayout->addWidget( textLabel1_2_3, 2, 6 );

    yPositionText = new QLineEdit( controlPanelGroup, "yPositionText" );
    yPositionText->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, yPositionText->sizePolicy().hasHeightForWidth() ) );
    yPositionText->setMinimumSize( QSize( 40, 0 ) );
    yPositionText->setMaximumSize( QSize( 32767, 32767 ) );

    controlPanelGroupLayout->addWidget( yPositionText, 1, 7 );

    refractionText = new QLineEdit( controlPanelGroup, "refractionText" );
    refractionText->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, refractionText->sizePolicy().hasHeightForWidth() ) );
    refractionText->setMinimumSize( QSize( 40, 0 ) );
    refractionText->setMaximumSize( QSize( 32767, 32767 ) );

    controlPanelGroupLayout->addWidget( refractionText, 2, 7 );

    dispersionText = new QLineEdit( controlPanelGroup, "dispersionText" );
    dispersionText->setMinimumSize( QSize( 40, 0 ) );
    dispersionText->setMaximumSize( QSize( 32767, 32767 ) );

    controlPanelGroupLayout->addWidget( dispersionText, 3, 7 );

    textLabel1_4 = new QLabel( controlPanelGroup, "textLabel1_4" );

    controlPanelGroupLayout->addWidget( textLabel1_4, 3, 6 );

    symmetricalCheckBox = new QCheckBox( controlPanelGroup, "symmetricalCheckBox" );

    controlPanelGroupLayout->addMultiCellWidget( symmetricalCheckBox, 3, 3, 4, 5 );

    rightHypCheckBox = new QCheckBox( controlPanelGroup, "rightHypCheckBox" );

    controlPanelGroupLayout->addMultiCellWidget( rightHypCheckBox, 3, 3, 2, 3 );

    leftHypCheckBox = new QCheckBox( controlPanelGroup, "leftHypCheckBox" );

    controlPanelGroupLayout->addMultiCellWidget( leftHypCheckBox, 3, 3, 0, 1 );

    xPositionText = new QLineEdit( controlPanelGroup, "xPositionText" );
    xPositionText->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)5, (QSizePolicy::SizeType)0, 0, 0, xPositionText->sizePolicy().hasHeightForWidth() ) );
    xPositionText->setMinimumSize( QSize( 40, 0 ) );
    xPositionText->setMaximumSize( QSize( 32767, 32767 ) );

    controlPanelGroupLayout->addWidget( xPositionText, 0, 7 );

    mainGroupBoxLayout->addMultiCellWidget( controlPanelGroup, 2, 2, 0, 4 );

    rayTracePageLayout->addWidget( mainGroupBox, 0, 0 );
    mainTabWidget->insertTab( rayTracePage, QString::fromLatin1("") );

    configurationPage = new QWidget( mainTabWidget, "configurationPage" );
    configurationPageLayout = new QGridLayout( configurationPage, 1, 1, 11, 6, "configurationPageLayout"); 

    configurationLayout = new QGroupBox( configurationPage, "configurationLayout" );
    configurationLayout->setColumnLayout(0, Qt::Vertical );
    configurationLayout->layout()->setSpacing( 0 );
    configurationLayout->layout()->setMargin( 11 );
    configurationLayoutLayout = new QGridLayout( configurationLayout->layout() );
    configurationLayoutLayout->setAlignment( Qt::AlignTop );

    textLabel1_5_3_3 = new QLabel( configurationLayout, "textLabel1_5_3_3" );
    textLabel1_5_3_3->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    configurationLayoutLayout->addWidget( textLabel1_5_3_3, 7, 0 );

    textLabel1_5_3 = new QLabel( configurationLayout, "textLabel1_5_3" );
    textLabel1_5_3->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    configurationLayoutLayout->addWidget( textLabel1_5_3, 6, 0 );

    textLabel1_5_4_2 = new QLabel( configurationLayout, "textLabel1_5_4_2" );
    textLabel1_5_4_2->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    configurationLayoutLayout->addWidget( textLabel1_5_4_2, 1, 0 );

    textLabel1_5_3_3_2_5_2 = new QLabel( configurationLayout, "textLabel1_5_3_3_2_5_2" );
    textLabel1_5_3_3_2_5_2->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    configurationLayoutLayout->addWidget( textLabel1_5_3_3_2_5_2, 9, 0 );

    textLabel1_5_3_3_2_5 = new QLabel( configurationLayout, "textLabel1_5_3_3_2_5" );
    textLabel1_5_3_3_2_5->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    configurationLayoutLayout->addWidget( textLabel1_5_3_3_2_5, 5, 0 );

    textLabel1_5 = new QLabel( configurationLayout, "textLabel1_5" );
    textLabel1_5->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    configurationLayoutLayout->addWidget( textLabel1_5, 2, 0 );

    textLabel1_5_3_3_3 = new QLabel( configurationLayout, "textLabel1_5_3_3_3" );
    textLabel1_5_3_3_3->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    configurationLayoutLayout->addWidget( textLabel1_5_3_3_3, 8, 0 );

    textLabel1_5_2 = new QLabel( configurationLayout, "textLabel1_5_2" );
    textLabel1_5_2->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    configurationLayoutLayout->addWidget( textLabel1_5_2, 3, 0 );

    textLabel1_5_3_2 = new QLabel( configurationLayout, "textLabel1_5_3_2" );
    textLabel1_5_3_2->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    configurationLayoutLayout->addWidget( textLabel1_5_3_2, 4, 0 );

    textLabel1_5_3_3_2_4 = new QLabel( configurationLayout, "textLabel1_5_3_3_2_4" );
    textLabel1_5_3_3_2_4->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    configurationLayoutLayout->addMultiCellWidget( textLabel1_5_3_3_2_4, 9, 9, 2, 3 );

    textLabel1_5_3_3_2_4_2_3_2 = new QLabel( configurationLayout, "textLabel1_5_3_3_2_4_2_3_2" );
    textLabel1_5_3_3_2_4_2_3_2->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    configurationLayoutLayout->addMultiCellWidget( textLabel1_5_3_3_2_4_2_3_2, 8, 8, 2, 3 );

    textLabel1_5_3_3_2_2 = new QLabel( configurationLayout, "textLabel1_5_3_3_2_2" );
    textLabel1_5_3_3_2_2->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    configurationLayoutLayout->addMultiCellWidget( textLabel1_5_3_3_2_2, 3, 3, 2, 3 );

    textLabel1_5_3_3_2_3 = new QLabel( configurationLayout, "textLabel1_5_3_3_2_3" );
    textLabel1_5_3_3_2_3->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    configurationLayoutLayout->addMultiCellWidget( textLabel1_5_3_3_2_3, 4, 4, 2, 3 );

    textLabel1_5_3_3_2_4_2_2 = new QLabel( configurationLayout, "textLabel1_5_3_3_2_4_2_2" );
    textLabel1_5_3_3_2_4_2_2->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    configurationLayoutLayout->addMultiCellWidget( textLabel1_5_3_3_2_4_2_2, 5, 5, 2, 3 );

    textLabel1_5_3_3_2_4_2 = new QLabel( configurationLayout, "textLabel1_5_3_3_2_4_2" );
    textLabel1_5_3_3_2_4_2->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    configurationLayoutLayout->addMultiCellWidget( textLabel1_5_3_3_2_4_2, 6, 6, 2, 3 );

    textLabel1_5_3_3_2_4_2_3 = new QLabel( configurationLayout, "textLabel1_5_3_3_2_4_2_3" );
    textLabel1_5_3_3_2_4_2_3->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    configurationLayoutLayout->addMultiCellWidget( textLabel1_5_3_3_2_4_2_3, 7, 7, 2, 3 );

    textLabel1_5_3_3_2_7 = new QLabel( configurationLayout, "textLabel1_5_3_3_2_7" );
    textLabel1_5_3_3_2_7->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    configurationLayoutLayout->addMultiCellWidget( textLabel1_5_3_3_2_7, 2, 2, 2, 3 );

    textLabel1_5_3_3_2 = new QLabel( configurationLayout, "textLabel1_5_3_3_2" );
    textLabel1_5_3_3_2->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    configurationLayoutLayout->addMultiCellWidget( textLabel1_5_3_3_2, 1, 1, 2, 3 );

    textLabel1_5_3_3_2_6 = new QLabel( configurationLayout, "textLabel1_5_3_3_2_6" );
    textLabel1_5_3_3_2_6->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    configurationLayoutLayout->addMultiCellWidget( textLabel1_5_3_3_2_6, 0, 0, 2, 3 );

    divergingSourceCheckBox = new QCheckBox( configurationLayout, "divergingSourceCheckBox" );
    divergingSourceCheckBox->setMaximumSize( QSize( 80, 32767 ) );

    configurationLayoutLayout->addWidget( divergingSourceCheckBox, 8, 4 );

    textLabel1_5_4 = new QLabel( configurationLayout, "textLabel1_5_4" );
    textLabel1_5_4->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    configurationLayoutLayout->addWidget( textLabel1_5_4, 0, 0 );

    yBaselineColorButton = new QPushButton( configurationLayout, "yBaselineColorButton" );
    yBaselineColorButton->setMaximumSize( QSize( 80, 21 ) );
    yBaselineColorButton->setPaletteBackgroundColor( QColor( 0, 0, 0 ) );
    yBaselineColorButton->setToggleButton( TRUE );
    yBaselineColorButton->setFlat( FALSE );

    configurationLayoutLayout->addWidget( yBaselineColorButton, 0, 1 );

    gridColorButton = new QPushButton( configurationLayout, "gridColorButton" );
    gridColorButton->setMaximumSize( QSize( 80, 21 ) );
    gridColorButton->setPaletteBackgroundColor( QColor( 0, 0, 0 ) );
    gridColorButton->setToggleButton( TRUE );
    gridColorButton->setFlat( FALSE );

    configurationLayoutLayout->addWidget( gridColorButton, 1, 1 );

    dispColorButton = new QPushButton( configurationLayout, "dispColorButton" );
    dispColorButton->setMaximumSize( QSize( 80, 21 ) );
    dispColorButton->setPaletteBackgroundColor( QColor( 0, 0, 0 ) );
    dispColorButton->setToggleButton( TRUE );
    dispColorButton->setFlat( FALSE );

    configurationLayoutLayout->addWidget( dispColorButton, 2, 1 );

    beamColorButton = new QPushButton( configurationLayout, "beamColorButton" );
    beamColorButton->setMaximumSize( QSize( 80, 21 ) );
    beamColorButton->setPaletteBackgroundColor( QColor( 0, 0, 0 ) );
    beamColorButton->setToggleButton( TRUE );
    beamColorButton->setFlat( FALSE );

    configurationLayoutLayout->addWidget( beamColorButton, 3, 1 );

    intersectionColorButton = new QPushButton( configurationLayout, "intersectionColorButton" );
    intersectionColorButton->setMaximumSize( QSize( 80, 21 ) );
    intersectionColorButton->setPaletteBackgroundColor( QColor( 0, 0, 0 ) );
    intersectionColorButton->setToggleButton( TRUE );
    intersectionColorButton->setFlat( FALSE );

    configurationLayoutLayout->addWidget( intersectionColorButton, 4, 1 );

    lensDefColorButton = new QPushButton( configurationLayout, "lensDefColorButton" );
    lensDefColorButton->setMaximumSize( QSize( 80, 21 ) );
    lensDefColorButton->setPaletteBackgroundColor( QColor( 0, 0, 0 ) );
    lensDefColorButton->setToggleButton( TRUE );
    lensDefColorButton->setFlat( FALSE );

    configurationLayoutLayout->addWidget( lensDefColorButton, 6, 1 );

    lensSelColorButton = new QPushButton( configurationLayout, "lensSelColorButton" );
    lensSelColorButton->setMaximumSize( QSize( 80, 21 ) );
    lensSelColorButton->setPaletteBackgroundColor( QColor( 0, 0, 0 ) );
    lensSelColorButton->setToggleButton( TRUE );
    lensSelColorButton->setFlat( FALSE );

    configurationLayoutLayout->addWidget( lensSelColorButton, 7, 1 );

    lensOutlineColorButton = new QPushButton( configurationLayout, "lensOutlineColorButton" );
    lensOutlineColorButton->setMaximumSize( QSize( 80, 21 ) );
    lensOutlineColorButton->setPaletteBackgroundColor( QColor( 0, 0, 0 ) );
    lensOutlineColorButton->setToggleButton( TRUE );
    lensOutlineColorButton->setFlat( FALSE );

    configurationLayoutLayout->addWidget( lensOutlineColorButton, 8, 1 );

    beamWidthText = new QLineEdit( configurationLayout, "beamWidthText" );
    beamWidthText->setMaximumSize( QSize( 80, 21 ) );

    configurationLayoutLayout->addWidget( beamWidthText, 0, 4 );

    tracingBeamsText = new QLineEdit( configurationLayout, "tracingBeamsText" );
    tracingBeamsText->setMaximumSize( QSize( 80, 21 ) );

    configurationLayoutLayout->addWidget( tracingBeamsText, 1, 4 );

    interactionsText = new QLineEdit( configurationLayout, "interactionsText" );
    interactionsText->setMaximumSize( QSize( 80, 21 ) );

    configurationLayoutLayout->addWidget( interactionsText, 2, 4 );

    yStartBeamPosText = new QLineEdit( configurationLayout, "yStartBeamPosText" );
    yStartBeamPosText->setMaximumSize( QSize( 80, 21 ) );

    configurationLayoutLayout->addWidget( yStartBeamPosText, 3, 4 );

    yEndBeamPosText = new QLineEdit( configurationLayout, "yEndBeamPosText" );
    yEndBeamPosText->setMaximumSize( QSize( 80, 21 ) );

    configurationLayoutLayout->addWidget( yEndBeamPosText, 4, 4 );

    xBeamSourceRefPlaneText = new QLineEdit( configurationLayout, "xBeamSourceRefPlaneText" );
    xBeamSourceRefPlaneText->setMaximumSize( QSize( 80, 21 ) );

    configurationLayoutLayout->addWidget( xBeamSourceRefPlaneText, 5, 4 );

    xBeamTargetRefPlaneText = new QLineEdit( configurationLayout, "xBeamTargetRefPlaneText" );
    xBeamTargetRefPlaneText->setMaximumSize( QSize( 80, 21 ) );

    configurationLayoutLayout->addWidget( xBeamTargetRefPlaneText, 6, 4 );

    beamAngleText = new QLineEdit( configurationLayout, "beamAngleText" );
    beamAngleText->setMaximumSize( QSize( 80, 21 ) );

    configurationLayoutLayout->addWidget( beamAngleText, 7, 4 );

    dispersionBeamsText = new QLineEdit( configurationLayout, "dispersionBeamsText" );
    dispersionBeamsText->setMaximumSize( QSize( 80, 21 ) );

    configurationLayoutLayout->addWidget( dispersionBeamsText, 9, 4 );

    ySnapText = new QLineEdit( configurationLayout, "ySnapText" );
    ySnapText->setMaximumSize( QSize( 80, 21 ) );

    configurationLayoutLayout->addWidget( ySnapText, 9, 1 );

    intersectionDotRadiusText = new QLineEdit( configurationLayout, "intersectionDotRadiusText" );
    intersectionDotRadiusText->setMaximumSize( QSize( 80, 21 ) );

    configurationLayoutLayout->addWidget( intersectionDotRadiusText, 5, 1 );
    spacer3 = new QSpacerItem( 550, 70, QSizePolicy::Minimum, QSizePolicy::Expanding );
    configurationLayoutLayout->addMultiCell( spacer3, 11, 11, 0, 4 );

    demoButton = new QPushButton( configurationLayout, "demoButton" );

    configurationLayoutLayout->addMultiCellWidget( demoButton, 10, 10, 1, 2 );
    spacer4 = new QSpacerItem( 171, 31, QSizePolicy::Expanding, QSizePolicy::Minimum );
    configurationLayoutLayout->addMultiCell( spacer4, 10, 10, 3, 4 );

    configurationPageLayout->addWidget( configurationLayout, 0, 0 );
    mainTabWidget->insertTab( configurationPage, QString::fromLatin1("") );

    helpPage = new QWidget( mainTabWidget, "helpPage" );
    mainTabWidget->insertTab( helpPage, QString::fromLatin1("") );

    TabPage = new QWidget( mainTabWidget, "TabPage" );
    TabPageLayout = new QGridLayout( TabPage, 1, 1, 11, 6, "TabPageLayout"); 

    aboutGroupBox = new QGroupBox( TabPage, "aboutGroupBox" );
    aboutGroupBox->setEnabled( TRUE );
    QFont aboutGroupBox_font(  aboutGroupBox->font() );
    aboutGroupBox->setFont( aboutGroupBox_font ); 
    aboutGroupBox->setColumnLayout(0, Qt::Vertical );
    aboutGroupBox->layout()->setSpacing( 6 );
    aboutGroupBox->layout()->setMargin( 11 );
    aboutGroupBoxLayout = new QGridLayout( aboutGroupBox->layout() );
    aboutGroupBoxLayout->setAlignment( Qt::AlignTop );

    aboutText = new QTextEdit( aboutGroupBox, "aboutText" );
    QFont aboutText_font(  aboutText->font() );
    aboutText_font.setFamily( "Courier 10 Pitch" );
    aboutText->setFont( aboutText_font ); 
    aboutText->setReadOnly( TRUE );

    aboutGroupBoxLayout->addWidget( aboutText, 0, 0 );

    TabPageLayout->addWidget( aboutGroupBox, 0, 0 );
    mainTabWidget->insertTab( TabPage, QString::fromLatin1("") );

    raytracerwidgetbaseLayout->addWidget( mainTabWidget, 0, 0 );
    languageChange();
    resize( QSize(664, 473).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( mainTabWidget, SIGNAL( currentChanged(QWidget*) ), this, SLOT( tabChanged(QWidget*) ) );
    connect( newButton, SIGNAL( clicked() ), this, SLOT( newLens() ) );
    connect( cloneButton, SIGNAL( clicked() ), this, SLOT( cloneLens() ) );
    connect( deleteButton, SIGNAL( clicked() ), this, SLOT( deleteLens() ) );
    connect( showHideButton, SIGNAL( clicked() ), this, SLOT( showHidePressed() ) );
    connect( dispersionText, SIGNAL( returnPressed() ), this, SLOT( lensDescriptionChanged() ) );
    connect( leftCurvatureText, SIGNAL( returnPressed() ), this, SLOT( lensDescriptionChanged() ) );
    connect( leftHypCheckBox, SIGNAL( stateChanged(int) ), this, SLOT( lensDescriptionChanged() ) );
    connect( rightHypCheckBox, SIGNAL( stateChanged(int) ), this, SLOT( lensDescriptionChanged() ) );
    connect( refractionText, SIGNAL( returnPressed() ), this, SLOT( lensDescriptionChanged() ) );
    connect( thicknessText, SIGNAL( returnPressed() ), this, SLOT( lensDescriptionChanged() ) );
    connect( xPositionText, SIGNAL( returnPressed() ), this, SLOT( lensDescriptionChanged() ) );
    connect( yPositionText, SIGNAL( returnPressed() ), this, SLOT( lensDescriptionChanged() ) );
    connect( lensRadiusText, SIGNAL( returnPressed() ), this, SLOT( lensDescriptionChanged() ) );
    connect( rightCurvatureText, SIGNAL( returnPressed() ), this, SLOT( lensDescriptionChanged() ) );
    connect( leftRadiusText, SIGNAL( returnPressed() ), this, SLOT( lensDescriptionChanged() ) );
    connect( rightRadiusText, SIGNAL( returnPressed() ), this, SLOT( lensDescriptionChanged() ) );
    connect( dispColorButton, SIGNAL( toggled(bool) ), this, SLOT( chooseColor() ) );
    connect( beamColorButton, SIGNAL( toggled(bool) ), this, SLOT( chooseColor() ) );
    connect( lensDefColorButton, SIGNAL( toggled(bool) ), this, SLOT( chooseColor() ) );
    connect( lensSelColorButton, SIGNAL( toggled(bool) ), this, SLOT( chooseColor() ) );
    connect( intersectionColorButton, SIGNAL( toggled(bool) ), this, SLOT( chooseColor() ) );
    connect( tracingBeamsText, SIGNAL( returnPressed() ), this, SLOT( globalDescriptionChanged() ) );
    connect( yStartBeamPosText, SIGNAL( returnPressed() ), this, SLOT( globalDescriptionChanged() ) );
    connect( yEndBeamPosText, SIGNAL( returnPressed() ), this, SLOT( globalDescriptionChanged() ) );
    connect( dispersionBeamsText, SIGNAL( returnPressed() ), this, SLOT( globalDescriptionChanged() ) );
    connect( xBeamSourceRefPlaneText, SIGNAL( returnPressed() ), this, SLOT( globalDescriptionChanged() ) );
    connect( xBeamTargetRefPlaneText, SIGNAL( returnPressed() ), this, SLOT( globalDescriptionChanged() ) );
    connect( beamAngleText, SIGNAL( returnPressed() ), this, SLOT( globalDescriptionChanged() ) );
    connect( dispersionBeamsText, SIGNAL( returnPressed() ), this, SLOT( globalDescriptionChanged() ) );
    connect( divergingSourceCheckBox, SIGNAL( clicked() ), this, SLOT( globalDescriptionChanged() ) );
    connect( intersectionDotRadiusText, SIGNAL( returnPressed() ), this, SLOT( globalDescriptionChanged() ) );
    connect( symmetricalCheckBox, SIGNAL( stateChanged(int) ), this, SLOT( lensDescriptionChanged() ) );
    connect( lensOutlineColorButton, SIGNAL( toggled(bool) ), this, SLOT( chooseColor() ) );
    connect( yBaselineColorButton, SIGNAL( toggled(bool) ), this, SLOT( chooseColor() ) );
    connect( gridColorButton, SIGNAL( toggled(bool) ), this, SLOT( chooseColor() ) );
    connect( ySnapText, SIGNAL( returnPressed() ), this, SLOT( globalDescriptionChanged() ) );
    connect( beamWidthText, SIGNAL( returnPressed() ), this, SLOT( globalDescriptionChanged() ) );
    connect( interactionsText, SIGNAL( returnPressed() ), this, SLOT( globalDescriptionChanged() ) );
    connect( demoButton, SIGNAL( clicked() ), this, SLOT( demoLenses() ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
raytracerWidgetBase::~raytracerWidgetBase()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void raytracerWidgetBase::languageChange()
{
    setCaption( tr2i18n( "raytracerwidgetbase" ) );
    mainGroupBox->setTitle( tr2i18n( "Ray Trace Display" ) );
    graphicDisplay->setText( QString::null );
    showHideButton->setText( tr2i18n( "Hide Controls" ) );
    showHideButton->setAccel( QKeySequence( QString::null ) );
    deleteButton->setText( tr2i18n( "Delete" ) );
    deleteButton->setAccel( QKeySequence( QString::null ) );
    cloneButton->setText( tr2i18n( "Cl&one" ) );
    cloneButton->setAccel( QKeySequence( tr2i18n( "Alt+O" ) ) );
    newButton->setText( tr2i18n( "&New" ) );
    newButton->setAccel( QKeySequence( tr2i18n( "Alt+N" ) ) );
    controlPanelGroup->setTitle( tr2i18n( "Lens Controls" ) );
    textLabel1_3->setText( tr2i18n( "Lens Thickness" ) );
    textLabel1_2_2_2_3->setText( tr2i18n( "Right Curv. Fact." ) );
    textLabel1->setText( tr2i18n( "Lens Radius" ) );
    textLabel1_2_2_2->setText( tr2i18n( "Left Curv. Fact." ) );
    textLabel1_2->setText( tr2i18n( "Left Sphere Radius" ) );
    textLabel1_2_2->setText( tr2i18n( "Right Sphere Radius" ) );
    textLabel1_3_2->setText( tr2i18n( "X position" ) );
    textLabel1_2_2_2_2->setText( tr2i18n( "Y position" ) );
    textLabel1_2_3->setText( tr2i18n( "IOR" ) );
    textLabel1_4->setText( tr2i18n( "Dispersion" ) );
    symmetricalCheckBox->setText( tr2i18n( "Symmetrical" ) );
    symmetricalCheckBox->setAccel( QKeySequence( QString::null ) );
    rightHypCheckBox->setText( tr2i18n( "Right H&yperboloid" ) );
    rightHypCheckBox->setAccel( QKeySequence( tr2i18n( "Alt+Y" ) ) );
    leftHypCheckBox->setText( tr2i18n( "Left Hyper&boloid" ) );
    leftHypCheckBox->setAccel( QKeySequence( tr2i18n( "Alt+B" ) ) );
    mainTabWidget->changeTab( rayTracePage, tr2i18n( "R&ay Trace Display" ) );
    configurationLayout->setTitle( tr2i18n( "Global Configuration" ) );
    textLabel1_5_3_3->setText( tr2i18n( "Lens Selected Box Color" ) );
    textLabel1_5_3->setText( tr2i18n( "Lens Default Box Color" ) );
    textLabel1_5_4_2->setText( tr2i18n( "Grid Color" ) );
    textLabel1_5_3_3_2_5_2->setText( tr2i18n( "Y Snap-to-Baseline Threshhold" ) );
    textLabel1_5_3_3_2_5->setText( tr2i18n( "Intersection Dot Radius (pixels)" ) );
    textLabel1_5->setText( tr2i18n( "Display Background Color" ) );
    textLabel1_5_3_3_3->setText( tr2i18n( "Lens Outline Color" ) );
    textLabel1_5_2->setText( tr2i18n( "Default Beam Color" ) );
    textLabel1_5_3_2->setText( tr2i18n( "Beam Intersection Color" ) );
    textLabel1_5_3_3_2_4->setText( tr2i18n( "Number of Dispersion Beams" ) );
    textLabel1_5_3_3_2_4_2_3_2->setText( tr2i18n( "Diverging Beam Source" ) );
    textLabel1_5_3_3_2_2->setText( tr2i18n( "Y Start Beam Position" ) );
    textLabel1_5_3_3_2_3->setText( tr2i18n( "Y End Beam Position" ) );
    textLabel1_5_3_3_2_4_2_2->setText( tr2i18n( "X Source Reference Plane" ) );
    textLabel1_5_3_3_2_4_2->setText( tr2i18n( "X Target Reference Plane" ) );
    textLabel1_5_3_3_2_4_2_3->setText( tr2i18n( "Beam Offset Angle (degrees)" ) );
    textLabel1_5_3_3_2_7->setText( tr2i18n( "Interactions Per Beam" ) );
    textLabel1_5_3_3_2->setText( tr2i18n( "Number of Tracing Beams" ) );
    textLabel1_5_3_3_2_6->setText( tr2i18n( "Tracing Beam Width (pixels)" ) );
    divergingSourceCheckBox->setText( QString::null );
    divergingSourceCheckBox->setAccel( QKeySequence( QString::null ) );
    textLabel1_5_4->setText( tr2i18n( "Y Baseline Color" ) );
    yBaselineColorButton->setText( QString::null );
    gridColorButton->setText( QString::null );
    dispColorButton->setText( QString::null );
    beamColorButton->setText( QString::null );
    intersectionColorButton->setText( QString::null );
    lensDefColorButton->setText( QString::null );
    lensSelColorButton->setText( QString::null );
    lensOutlineColorButton->setText( QString::null );
    demoButton->setText( tr2i18n( "Create Default Lenses" ) );
    demoButton->setAccel( QKeySequence( QString::null ) );
    mainTabWidget->changeTab( configurationPage, tr2i18n( "Co&nfiguration" ) );
    mainTabWidget->changeTab( helpPage, tr2i18n( "He&lp" ) );
    aboutGroupBox->setTitle( tr2i18n( "About..." ) );
    mainTabWidget->changeTab( TabPage, tr2i18n( "A&bout" ) );
}

void raytracerWidgetBase::tabChanged(QWidget*)
{
    qWarning( "raytracerWidgetBase::tabChanged(QWidget*): Not implemented yet" );
}

void raytracerWidgetBase::lensDescriptionChanged()
{
    qWarning( "raytracerWidgetBase::lensDescriptionChanged(): Not implemented yet" );
}

void raytracerWidgetBase::newLens()
{
    qWarning( "raytracerWidgetBase::newLens(): Not implemented yet" );
}

void raytracerWidgetBase::cloneLens()
{
    qWarning( "raytracerWidgetBase::cloneLens(): Not implemented yet" );
}

void raytracerWidgetBase::deleteLens()
{
    qWarning( "raytracerWidgetBase::deleteLens(): Not implemented yet" );
}

void raytracerWidgetBase::showHidePressed()
{
    qWarning( "raytracerWidgetBase::showHidePressed(): Not implemented yet" );
}

void raytracerWidgetBase::chooseColor()
{
    qWarning( "raytracerWidgetBase::chooseColor(): Not implemented yet" );
}

void raytracerWidgetBase::globalDescriptionChanged()
{
    qWarning( "raytracerWidgetBase::globalDescriptionChanged(): Not implemented yet" );
}

void raytracerWidgetBase::demoLenses()
{
    qWarning( "raytracerWidgetBase::demoLenses(): Not implemented yet" );
}

#include "raytracerwidgetbase.moc"
